﻿
Imports System.IO

Public Class FInicio

    Dim NombreArchivoTraducciones As String = "ArchivoTraduccionesText.txt"
    Dim LosTextos As New SortedList

    Private Sub FInicio_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CrearBaseParaArchivoTraducciones()
    End Sub

    Private Sub CrearBaseParaArchivoTraducciones()
        Dim NombreArchivo As String = Me.Name & ".TXT"  ' El archivo se creado en mismo lugar que el archivo EXE del proyecto (Debug o Release)
        Dim ArchivoParaEscribir As New StreamWriter(NombreArchivo, False, System.Text.Encoding.Default)
        Dim Linea As String

        ' Para el titulo del Form
        Linea = "ES" & "~" & Me.Name & "~" & Me.Text
        ArchivoParaEscribir.WriteLine(Linea)
        Linea = "US" & "~" & Me.Name & "~" & Me.Text  ' A traducir con Notepad en archivo
        ArchivoParaEscribir.WriteLine(Linea)

        ' Para las herramientas 
        '  !!! Atencion, para ListBox y ComboBox, si estas son llenado por lectura de una DB o de un archivo, este es ellos que tienes que traducir
        ' Para los MessageBox, DGV, y otros, tiene que agregar manualmente en el archivo

        For Each C As Control In Me.Controls
            Select Case C.GetType.Name
                Case "TextBox", "Label", "Button"
                    Linea = "ES" & "~" & C.Name & "~" & C.Text
                    ArchivoParaEscribir.WriteLine(Linea)
                    Linea = "US" & "~" & C.Name & "~" & C.Text    ' A traducir con Notepad en archivo
                    ArchivoParaEscribir.WriteLine(Linea)
                Case "ComboBox"
                    Dim Obj As ComboBox = C
                    For L As Integer = 0 To Obj.Items.Count - 1
                        Linea = "ES" & "~" & C.Name & "~" & Obj.Items(L)
                        ArchivoParaEscribir.WriteLine(Linea)
                        Linea = "US" & "~" & C.Name & "~" & Obj.Items(L)    ' A traducir con Notepad en archivo
                        ArchivoParaEscribir.WriteLine(Linea)
                    Next
                Case "ListBox"
                    Dim Obj As ListBox = C
                    For L As Integer = 0 To Obj.Items.Count - 1
                        Linea = "ES" & "~" & C.Name & "~" & Obj.Items(L)
                        ArchivoParaEscribir.WriteLine(Linea)
                        Linea = "US" & "~" & C.Name & "~" & Obj.Items(L)    ' A traducir con Notepad en archivo
                        ArchivoParaEscribir.WriteLine(Linea)
                    Next
                Case Else   ' Para RadioButton, CheckBox, y otro que tienen un propiede TEXT
                    Try
                        Dim Texto As String = C.Text
                        Linea = "ES" & "~" & C.Name & "~" & C.Text
                        ArchivoParaEscribir.WriteLine(Linea)
                        Linea = "US" & "~" & C.Name & "~" & C.Text    ' A traducir con Notepad en archivo
                        ArchivoParaEscribir.WriteLine(Linea)
                    Catch
                        '
                    End Try
            End Select
        Next
        ArchivoParaEscribir.Close()
        ArchivoParaEscribir.Dispose()
    End Sub

    Private Sub FInicio_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        RBES.Checked = True     ' Necesario para mostrar los mensajes iniciales
    End Sub

    Private Sub BMensaje_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BMensaje.Click
        ' Textos para el Msg MsgMensajeDado
        MessageBox.Show(LosTextos.GetByIndex(LosTextos.IndexOfKey("MsgMensajeDado02")), LosTextos.GetByIndex(LosTextos.IndexOfKey("MsgMensajeDado01")))
    End Sub

    Private Sub TraducirLasHerramientasYOtros(ByVal Lenguaje As String)

        If Not File.Exists(NombreArchivoTraducciones) Then
            Exit Sub
        End If

        Dim SeparadorSplit As Char() = {"~"}        ' Este caracter (ASCII 126) nunca es utilazado solo en una frase, en nungun languaje
        Dim ResultadoSplit() As String      ' Este es un tabla de String
        Dim Linea As String

        Dim ArchivoParaLeer As New StreamReader(NombreArchivoTraducciones, System.Text.Encoding.Default)

        LosTextos.Clear()
        LB10Numericos.Items.Clear()

        Do Until ArchivoParaLeer.Peek = -1
            Linea = ArchivoParaLeer.ReadLine()
            If Linea.Length > 1 Then
                ResultadoSplit = Linea.Split(SeparadorSplit)
                If ResultadoSplit(0) = Lenguaje Then
                    Select Case ResultadoSplit(1)       ' tratar las excepciones (ComboBox, ListBox, ...)
                        Case "LB10Numericos"       '  Un ListBox
                            LB10Numericos.Items.Add(ResultadoSplit(2))
                        Case "FInicio"       ' El titulo de este Form
                            Me.Text = ResultadoSplit(2)
                        Case Else       ' TextBox, Label, Button, ...   (los MessageBox son en LosTextos y son mostrado cuando este es necesario : cf. BMensaje_Click)
                            LosTextos.Add(ResultadoSplit(1), ResultadoSplit(2))
                    End Select
                End If
            End If
        Loop

        ArchivoParaLeer.Close()
        ArchivoParaLeer.Dispose()

        For Each O As Control In Me.Controls
            Try
                O.Text = LosTextos.GetByIndex(LosTextos.IndexOfKey(O.Name))
            Catch
            End Try
        Next

    End Sub

    Private Sub RB_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RBES.CheckedChanged, RBUS.CheckedChanged, RBFR.CheckedChanged

        ' El procedimiento RB_CheckedChanged pede ser remplazado por un BotonLanguaje_Click ...

        Select Case sender.name
            Case "RBES"
                TraducirLasHerramientasYOtros("ES")
            Case "RBUS"
                TraducirLasHerramientasYOtros("US")
            Case "RBFR"
                TraducirLasHerramientasYOtros("FR")
        End Select
    End Sub
End Class
